#!/usr/bin/env groovy

node {
 stage('Checkout') {
          checkout scm
          def pom = readMavenPom file: 'pom.xml'
          if (pom) {
            echo "Building version ${pom.version}"
          }
  }

  stage('Build') {
      parallel 'build': {
            withMaven(jdk: 'Java 17', maven: 'Maven 3.9.2'){
                sh "mvn compile"
                archiveArtifacts artifacts: '**/target/*.*'
            }
        }, 'Hello World': {
            echo 'Hello World'
        }
  }

  stage('Unit Tests') {
      withMaven(jdk: 'Java 17', maven: 'Maven 3.9.2') {
          sh "mvn test"
      }
  }

  stage('Code Quality Analysis') {
      withSonarQubeEnv('SonarCloud'){
      withMaven(jdk: 'Java 17', maven: 'Maven 3.9.2') {
          sh "mvn clean verify org.sonarsource.scanner.maven:sonar-maven-plugin:sonar -Dsonar.projectKey=karl.delourmel"
      }}
  }

  stage('Package and Deploy') {
      withMaven(jdk: 'Java 17', maven: 'Maven 3.9.2') {
          sh "mvn package"
      }
  }
}
